#include "stdafx.h"
#include "UpgradePrepareModule.h"
#include "UpgradeInstallModule.h"
#include "util.h"
#include <memory>

UpgradePrepareModule::UpgradePrepareModule(const TCHAR *guid, int execute_option) : IPrepareModule(guid), m_execute_option(execute_option)
{

}

UpgradePrepareModule::~UpgradePrepareModule()
{	
}

BOOL UpgradePrepareModule::Prepare()
{
	CALLBACK_FINISHED_STATUS ret = CALLBACK_FINISHED_SUCCESS;
	NAVERAPP_INSTALL_STATUS install_status = GetInstallStatusWithGuid(GetGuid());
	switch( install_status )
	{
	case NotInstalled:
		SetError();
		ret = CALLBACK_FINISHED_ERROR;
		break;

	default:
		break;
	}

	if( IsCancel() )
		ret = CALLBACK_FINISHED_CANCEL;

	SetModuleStatus(ModuleStatusFINISHED);
	GetCallback()->OnFinished(ret, NULL);
	return TRUE;
}

IInstallModule* UpgradePrepareModule::GetInstallComponent()
{
	return new UpgradeInstallModule(GetGuid(), m_execute_option);
}
